/*
 *  Copyright (C) 2005  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */



#ifndef DFA_H
#define DFA_H

#include <grammar.h>

typedef struct _dfa_state_t dfa_state_t;
typedef struct _dfa_t dfa_t;

dfa_state_t* dfa_state_new (gint, gboolean);
void dfa_state_delete (dfa_state_t*);
dfa_t* dfa_new (nextcb, gpointer);
void dfa_delete (dfa_t*);
gboolean dfa_add (dfa_t*, dfa_state_t*, symbol_t*, dfa_state_t*);
gpointer dfa_build (dfa_t*);

#endif
