/*
 *  Copyright (C) 2005  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */



/*
 * Copyright 2005 Thadeu Lima de Souza Cascardo
 *
 * libgrammatic
 *
 * Translate a grammar to a DFA table, if it is possible, i.e., it's a
 * regular grammar and has no non-determinism.
 *
 */

#include <grammar.h>
#include <dfa.h>

void dfa_gen_add (gpointer key, gpointer val, gpointer data)
{

  symbol_t* left;
  rule_t* right;
  dfa_t* dfa;
  GList* l;

  left = (symbol_t*) key;
  right = (rule_t*) val;
  dfa = (dfa_t*) data;

}

dfa_t* dfa_gen (grammar_t* grammar, symbol_t* start, nextcb cb, gpointer data)
{

  dfa_t* dfa;

  dfa = dfa_new (cb, data, dfa_state_new (start->value, FALSE));

  g_hash_table_foreach (grammar->grammar, dfa_gen_add, dfa);

  return dfa;

}
