/*
 *  Copyright (C) 2005  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */



#ifndef LR0_H
#define LR0_H

#include "parser.h"

typedef enum
  {
    PARSER_SHIFT,
    PARSER_REDUCE,
    PARSER_ACCEPT,
  } action_t;

typedef struct
{
  gint state;
  gpointer attrib;
} state_t;

typedef struct
{
  gint action;
  gint state;
} transition_t;

typedef struct
{
  nextcb cb;
  gpointer data;
  GList* stack;
  GHashTable* table;
  GList* rules;
} lr0_t;

transition_t* transition_new (gint, gint);
lr0_t* lr0_new (nextcb, gpointer);
void lr0_delete (lr0_t*);
void lr0_add (lr0_t*, gint, symbol_t*, transition_t*);
gpointer lr0_build (lr0_t*);

#endif
