/*
 *  Copyright (C) 2005  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */



#ifndef LR1_H
#define LR1_H

#include <grammar.h>

typedef struct _transition_t transition_t;
typedef struct _lr1_t lr1_t;

transition_t* transition_shift_new (gint);
transition_t* transition_reduce_new (symbol_t*, rule_t*);
transition_t* transition_accept_new ();
void transition_delete (transition_t*);
lr1_t* lr1_new (nextcb, gpointer);
void lr1_delete (lr1_t*);
gboolean lr1_add (lr1_t*, gint, symbol_t*, transition_t*);
void lr1_push (lr1_t*, gint, gpointer);
gpointer lr1_build (lr1_t*);

#endif
