/*
 *  Copyright (C) 2005  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */



#include <stdio.h>
#include <stdlib.h>
#include <scanner.h>

static void string_free (gpointer data)
{
  g_string_free ((GString*) data, TRUE);
}

scanner_t* scanner_new (readcb cb, gpointer data)
{

  scanner_t* scanner;

  scanner = g_malloc (sizeof (scanner_t));
  scanner->cb = cb;
  scanner->data = data;
  scanner->buffer = g_string_sized_new (256);
  scanner->reserved = g_hash_table_new_full (g_string_hash, g_string_equal,
					     string_free, NULL);

  return scanner;

}

void scanner_delete (scanner_t* scanner)
{
  g_hash_table_destroy (scanner->reserved);
  g_string_free (scanner->buffer, TRUE);
  g_free (scanner);
}
